package com.steerinfo.baseinfo.meterbaseunitdirect.controller;

import com.steerinfo.baseinfo.meterbasetimespace.model.MeterBaseTimeSpace;
import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.user.UserPayload;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.baseinfo.meterbaseunitdirect.model.MeterBaseUnitDirect;
import com.steerinfo.baseinfo.meterbaseunitdirect.service.IMeterBaseUnitDirectService;
import com.steerinfo.meterwork.except.MarkerMetException;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import oracle.jdbc.proxy.annotation.Post;
import org.apache.commons.lang3.StringUtils;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.transaction.interceptor.TransactionAspectSupport;
import org.springframework.web.bind.annotation.*;

import java.util.*;
import java.math.BigDecimal;

/**
 * MeterBaseUnitDirect RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2022-02-14 11:33
 * 类描述
 * 修订历史：
 * 日期：2022-02-14
 * 作者：generator
 * 参考：
 * 描述：MeterBaseUnitDirect RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/meterbaseunitdirects")
@Api(value = "/${api.version}/meterbasematterinfodirects", tags = "承运单位名称表直接录入 - MeterBaseUnitDirectController")
public class MeterBaseUnitDirectController extends BaseRESTfulController {

    @Autowired
    IMeterBaseUnitDirectService meterBaseUnitDirectService;

    @ApiOperation(value="获取列表", notes="分页查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbaseunitdirect:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterBaseUnitDirect> list = meterBaseUnitDirectService.queryForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbaseunitdirect:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterBaseUnitDirect> list = meterBaseUnitDirectService.queryLikeForPage(parmas, pageNum, pageSize);
        return success(list);
    }
    
    @ApiOperation(value="创建", notes="根据MeterBaseUnitDirect对象创建")
    @ApiImplicitParam(name = "meterBaseUnitDirect", value = "详细实体meterBaseUnitDirect", required = true, dataType = "MeterBaseUnitDirect")
    //@RequiresPermissions("meterbaseunitdirect:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@RequestBody MeterBaseUnitDirect model){
        try{
            String msg = meterBaseUnitDirectService.checkandadd(model);
            if (msg != "" && !msg.equals("")) {
                return  failed(null,msg);
            }
        }catch (Exception e){
            e.printStackTrace();
            return failed(null,"操作异常，请确认！");
        }
        return success();
    }

    @ApiOperation(value="获取详细信息", notes="根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbaseunitdirect:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id){
        MeterBaseUnitDirect meterBaseUnitDirect = meterBaseUnitDirectService.getById(id);
        return success(meterBaseUnitDirect);
    }

    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的meterBaseUnitDirect信息来更新详细信息")
    @ApiImplicitParams({
        @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
        @ApiImplicitParam(name = "meterBaseUnitDirect", value = "详细实体meterBaseUnitDirect", required = true, dataType = "MeterBaseUnitDirect")
    })
    //@RequiresPermissions("meterbaseunitdirect:update")
    @PutMapping(value = "/{id}", produces  = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody MeterBaseUnitDirect model){
        try {
            String msg = meterBaseUnitDirectService.checkandupdate(id,model);
            if (msg != "" && !msg.equals("")){
                return failed(null,msg);
            }
        }catch (Exception e){
            e.printStackTrace();
            return failed(null,"操作异常，请确认！");
        }
        return success();
    }

    @ApiOperation(value="删除", notes="根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbaseunitdirect:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id){
    	List<String> list = Arrays.asList(id.split(","));
    	if(ListUtils.isNotEmpty(list)) {
	    	List<String> ids = ListUtils.convertList(list);
			  meterBaseUnitDirectService.delete(ids);
    	}
      return success();
    }

    @ApiOperation(value = "批量删除", notes = "根据MeterBaseUnitDirect对象批量删除")
    @ApiImplicitParam(paramType = "path",  required = true, dataType = "List<MeterBaseUnitDirect>")
    @Transactional
    @PutMapping(value = "/batchdelete")//String
    public RESTfulResult batchsdelete(@RequestBody List<MeterBaseUnitDirect> models) {
        try {
            UserPayload payload = UserPayload.getCurrUser();
            String userId = payload.getUserCode();
            String userName = payload.getUserName();
            for (MeterBaseUnitDirect model : models){
                model.setDeleteManNo(userId);
                model.setDeleteManName(userName);
                model.setDeleteTime(new Date());
                model.setValidFlag("0");
            }
            meterBaseUnitDirectService.batchUpdate(models);
            return success();
        } catch (Exception ex) {
            ex.printStackTrace();
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

}
